// Заголовочные файлы
#include "MDR32FxQI_rst_clk.h"          // Keil::Drivers:RST_CLK
#include "MDR32FxQI_port.h"             // Keil::Drivers:PORT

// Прототип функции задержки, реализованной ниже
void Delay(int waitTicks);

#define _test1901 // Выбираем секцию К1901ВЦ1QI для компиляции
#ifdef _testBE9x // Определения для K1986ВЕ92QI - неактивна при выбранном ключе
  #define PORT_LedClock RST_CLK_PCLK_PORTC
  #define PORT_Led MDR_PORTC
  #define PORT_LedPin PORT_Pin_0
  #define DELAY_Ticks 1000000
#endif
#ifdef _test1901 // Определения для К1901ВЦ1QI - активна
  #define PORT_LedClock RST_CLK_PCLK_PORTB
  #define PORT_Led MDR_PORTB
  #define PORT_LedPin PORT_Pin_11
  #define DELAY_Ticks 1000000
#endif

// Точка входа, отсюда начинается исполнение программы
int main() {
  // Заводим структуру конфигурации вывода(-ов) порта
  PORT_InitTypeDef GPIOInitStruct;
  
  // Включаем тактирование порта В (для К1901ВЦ1QI)
  RST_CLK_PCLKcmd (PORT_LedClock, ENABLE);
  
  // Инициализируем структуру конфигурации вывода(-ов) порта значениями по умолчанию
  PORT_StructInit(&GPIOInitStruct);
  
  // Изменяем значения по умолчанию на необходимые нам настройки
  GPIOInitStruct.PORT_Pin        = PORT_LedPin;
  GPIOInitStruct.PORT_OE         = PORT_OE_OUT;
  GPIOInitStruct.PORT_SPEED      = PORT_SPEED_SLOW;
  GPIOInitStruct.PORT_MODE       = PORT_MODE_DIGITAL;
  
  // Применяем заполненную нами структуру для PORTB
  PORT_Init(PORT_Led, &GPIOInitStruct);
  
  // Запускаем бесконечный цикл обработки - Основной цикл
  while (1){
    // Считываем состояние вывода PB11
    // Если на выводе логический "0", то выставляем вывод в логическую "1"
    if (PORT_ReadInputDataBit (PORT_Led, PORT_LedPin) == 0){
      PORT_SetBits(PORT_Led, PORT_LedPin); // LED
    }
    
    // Задержка
    Delay(1000000);
    
    // Считываем состояние вывода PB11
    // Если на выводе = "1", то выставляем "0"
    if (PORT_ReadInputDataBit (PORT_Led, PORT_LedPin) == 1){
      PORT_ResetBits(PORT_Led, PORT_LedPin);
    }
    
    // Задержка
    Delay(1000000);
  }
}

// Простейшая функция задержки, позднее мы заменим ее на реализацию через таймер
void Delay(int waitTicks){
  int i;
  for (i = 0; i < waitTicks; i++){
    __NOP();
  }
}
